﻿Option Explicit On
Option Compare Binary
Option Strict On
Imports System.Math

Module ServiceApproximation

    Friend Sub ApproximationDerivatives(ByRef hi() As Double, ByVal nhi As Integer, Optional ByRef Hij() As Double = Nothing)
        'конечно-разностная аппроксимация первых и вторых производных
        'h() - массив конечно-разностных интервалов
        'nhi
        '   nhi = 0 - конечно-разностная аппроксимация первых производных
        '   nhi = 1 - конечно-разностная аппроксимация первых и вторых производных
        Dim i, j, l As Integer
        Dim xki, xkj, hki, hkj As Double
        Dim F, Fl As Double
        Dim y(n - 1) As Double
        l = 0
        For i = 0 To n - 1
            xki = xk(i)
            hki = h(i) * (1 + Abs(xki))
            xk(i) = xki + hki
            F = func(sF, xk)
            nf += 1
            y(i) = F
            xk(i) = xki - hki
            Fl = func(sF, xk)
            nf += 1
            hi(i) = (F - Fl) / (hki + hki)
            If nhi = 1 Then
                xk(i) = xki + hki + hki
                Fl = func(sF, xk)
                nf += 1
                Hij(l) = ((Fl + Fk) - (F + F)) / (hki * hki)
                l += n - i
            End If
            xk(i) = xki
        Next
        If nhi = 1 Then
            l = 0
            For i = 0 To n - 1
                xki = xk(i)
                hki = h(i) * (1 + Abs(xki))
                xk(i) = xki + hki
                For j = i To n - 1
                    If i <> j Then
                        xkj = xk(j)
                        hkj = h(j) * (1 + Abs(xkj))
                        xk(j) = xkj + hkj
                        F = func(sF, xk)
                        nf += 1
                        Hij(l) = ((F + Fk) - (y(i) + y(j))) / (hki * hkj)
                        xk(j) = xkj
                    End If
                    l += 1
                Next
                xk(i) = xki
            Next
        End If
    End Sub

    Friend Sub AutomaticIntervals()
        'оценивание конечно-разностных интервалов
        Dim i, j As Integer
        Dim xki As Double 'xki = xk(i)
        Dim he, Fl, Fp, Fe As Double
        For i = 0 To n - 1
            h(i) = beta
            xki = xk(i)
            For j = 0 To 48
                xk(i) = xki - h(i)
                Fl = func(sF, xk)
                nf += 1
                xk(i) = xki + h(i)
                Fp = func(sF, xk)
                nf += 1
                he = -(Fp - Fl) / (h(i) + h(i))
                xk(i) = xki + gamma * h(i) * he
                Fe = func(sF, xk)
                nf += 1
                If Fe - Fk < 0 Then
                    Exit For
                Else
                    h(i) *= 0.5
                End If
            Next
            xk(i) = xki
        Next
        For i = 0 To n - 1
            h(i) /= (1 + Abs(xk(i)))
        Next
    End Sub

End Module
