﻿Option Explicit On
Option Compare Binary
Option Strict On
Imports System
Imports System.IO
Imports System.String
Imports System.Windows.Forms
Imports System.Windows.Forms.Keys
Imports System.Windows.Forms.Cursors
Imports NMBMApp.IDBDataSet

Public Class frmContext

    Dim bs As New BindingSource()
    Dim eRowIndex As Integer 'индекс строки таблицы grd

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        With Me
            AddHandler .Load, AddressOf Me_Load
            AddHandler .FormClosing, AddressOf Me_FormClosing
            AddHandler .KeyDown, AddressOf Me_KeyDown
        End With
        AddHandler btnUpdate.Click, AddressOf btnUpdate_Click
        AddHandler btnAdd.Click, AddressOf btnAdd_Click
        AddHandler grdEdit.KeyDown, AddressOf grdEdit_KeyDown
        AddHandler btnExit.Click, AddressOf btnExit_Click
        AddHandler btnTools.Click, AddressOf btnTools_Click
        AddHandler btnDelete.Click, AddressOf btnDelete_Click
        AddHandler btnCancel.Click, AddressOf btnCancel_Click
        AddHandler btnDb.Click, AddressOf btnDb_Click
        AddHandler btnIdb.Click, AddressOf btnIdb_Click
        AddHandler btnOk.Click, AddressOf btnOk_Click
        AddHandler grd.RowEnter, AddressOf grd_RowEnter
        AddHandler ni.Click, AddressOf ni_Click

    End Sub

    Private Sub Me_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
        If e.KeyCode = Escape Then Close()
    End Sub

    Private Sub Me_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs)
        Call UpdateIdb()
        Opacity = 0
        MyClass.ni.Dispose()
        If Not (components Is Nothing) Then components.Dispose()
    End Sub

    Private Sub UpdateIdb()
        'редактирование информационной базы данных
        If intUpdate <> 0 Then
            If bMessage(2, "Редактирование", "Вы хотите сохранить изменения в информационной базе данных?", True) Then
                intUpdate = 0
                If File.Exists(strPathXml) Then File.Delete(strPathXml)
                globds.WriteXml(strPathXml, XmlWriteMode.DiffGram)
            End If
        End If
    End Sub

    Private Sub btnExit_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.Close()
    End Sub

    Private Sub Me_Load(ByVal sender As Object, ByVal e As EventArgs)
        If File.Exists(strPathXml) Then globds.ReadXml(strPathXml)
        With grdEdit
            .RowCount = 0
            Dim i As Integer = .Height - .ColumnHeadersHeight
            With .RowTemplate
                .Height = 1
                .MinimumHeight = i
            End With
        End With
        With bs
            .DataSource = globds.idbContext
            .Sort = "colNumber ASC"
        End With
        grd.DataSource = bs
        bn.BindingSource = bs
        If bs.Count <> 0 Then Call grdRowEnter()
        Dim tbox As New DataGridViewClassesColumn.DataGridViewTextBoxColumn
        Call tbox.TextBoxColumn(grdEdit, {"colNoteEdit", "colValueEdit"})
        Dim mbox As New DataGridViewClassesColumn.DataGridViewMaskedTextBoxColumn
        Call mbox.MaskedTextBoxColumn(grdEdit, {"colNumberEdit"}, {"###"})
        Call ModeWork(True)
    End Sub

    Private Sub ni_Click(ByVal sender As Object, ByVal e As EventArgs)
        'Opacity = 0 или 1 для всех открытых форм приложения
        Dim b As Boolean
        For Each f As Form In Application.OpenForms
            With f
                If .Opacity = 1 Then
                    .Opacity = 0
                    b = False
                Else
                    .Opacity = 1
                    b = True
                End If
            End With
        Next
        With ni
            If b Then
                ni.Text = ("NMBMApp (вкл) - ньютоновский метод безусловной минимизации")
            Else
                ni.Text = ("NMBMApp (выкл) - ньютоновский метод безусловной минимизации")
            End If
        End With
    End Sub

    Private Sub ModeWork(ByVal blnMode As Boolean)
        'инициализация
        With btnUpdate
            If bs.Count = 0 Then
                .Enabled = False
            Else
                If blnMode Then .Enabled = True Else .Enabled = False
            End If
        End With
        With btnDelete
            If bs.Count = 0 Then
                .Enabled = False
            Else
                If blnMode Then .Enabled = True Else .Enabled = False
            End If
        End With
        With btnAdd
            If blnMode Then .Enabled = True Else .Enabled = False
        End With
        With btnTools
            If bs.Count = 0 Then
                .Enabled = False
            Else
                If blnMode Then .Enabled = True Else .Enabled = False
            End If
        End With
        With btnOk
            If bs.Count = 0 Then
                .Enabled = False
            Else
                If blnMode Then .Enabled = True Else .Enabled = False
            End If
        End With
        With btnDb
            If blnMode Then .Enabled = False Else .Enabled = True
        End With
        With btnIdb
            If blnMode Then .Enabled = True Else .Enabled = False
        End With
        With chk
            If blnMode Then .Enabled = True Else .Enabled = False
        End With
        With grb
            If blnMode Then .Enabled = True Else .Enabled = False
        End With
        With grdEdit
            If blnMode Then .Enabled = False Else .Enabled = True
        End With
    End Sub

    Private Sub grd_RowEnter(ByVal sender As Object, ByVal e As DataGridViewCellEventArgs)
        If bs.Count <> 0 Then
            eRowIndex = e.RowIndex
            globGuid = CType(grd(0, eRowIndex).Value, Guid)
            globProblem = grd(3, eRowIndex).Value.ToString
            Call grdRowEnter()
        End If
    End Sub

    Private Sub grdRowEnter()
        With grdEdit
            If .RowCount <> 0 Then .Rows.RemoveAt(0)
            .Rows.Add(grd("colId", eRowIndex).Value, grd("colNumber", eRowIndex).Value, grd("colNote", eRowIndex).Value, grd("colValue", eRowIndex).Value)
        End With
    End Sub

    Private Sub grdEdit_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
        'редактирование grd
        With grdEdit
            If .CurrentCell.ColumnIndex = .ColumnCount - 1 Then
                If bMessage(2, "Редактирование", "Внести изменения в локальную базу данных? Enter - Да, Ecs - Нет", True) Then
                    btnDb.PerformClick()
                End If
                .CurrentCell = grdEdit(1, 0)
                e.Handled = True
            End If
        End With
    End Sub

    Private Sub btnAdd_Click(ByVal sender As Object, ByVal e As EventArgs)
        'добавление записи
        strClickButton = "Add"
        With grdEdit
            If .RowCount <> 0 Then .Rows.RemoveAt(0)
            .Rows.Add(Guid.NewGuid, "", "", "")
            Call ModeWork(False)
            .Focus()
            .CurrentCell = grdEdit(1, 0)
        End With
    End Sub

    Private Sub btnDelete_Click(ByVal sender As Object, ByVal e As EventArgs)
        'удаление записи
        If bs.Count > 0 Then
            If bMessage(2, "Редактирование", "Вы действительно хотите удалить эту запись?", True) Then
                Call ModeWork(False)
                With grd
                    If .RowCount <> 0 Then .Rows.RemoveAt(eRowIndex)
                    If .RowCount = 0 Then grdEdit.Rows.RemoveAt(0)
                    intUpdate = 2
                End With
                Call ModeWork(True)
            End If
        End If
    End Sub

    Private Sub btnUpdate_Click(ByVal sender As Object, ByVal e As EventArgs)
        'редактирование записи
        strClickButton = "Update"
        If bs.Count <> 0 Then Call ModeWork(False)
    End Sub

    Private Sub btnTools_Click(ByVal sender As Object, ByVal e As EventArgs)
        Cursor = WaitCursor
        Call UpdateIdb()
        Dim frmTools As New frmTools
        With frmTools
            .Text = "Настройки алгоритма (" & globProblem & ")"
            .ShowDialog()
        End With
        Cursor = Hand
    End Sub

    Private Sub btnCancel_Click(ByVal sender As Object, ByVal e As EventArgs)
        'отмена
        If intUpdate <> 2 Then intUpdate = 0
        With grb
            .Enabled = True
            globds.RejectChanges()
        End With
        If bs.Count <> 0 Then
            Call grdRowEnter()
        Else
            With grdEdit
                If .RowCount <> 0 Then .Rows.RemoveAt(0)
            End With
        End If
        Call ModeWork(True)
    End Sub

    Private Sub btnDb_Click(ByVal sender As Object, ByVal e As EventArgs)
        'редактирование
        Select Case strClickButton
            Case "Update"
                'редактирование строки в grd
                With grb
                    .Enabled = True
                    grd(1, eRowIndex).Value = grdEdit(1, 0).Value
                    grd(2, eRowIndex).Value = grdEdit(2, 0).Value
                    grd(3, eRowIndex).Value = grdEdit(3, 0).Value
                    .Enabled = False
                End With
            Case "Add"
                'добавление строки в grd
                If Len(grdEdit(1, 0).Value.ToString) = 0 Then
                    bMessage(1, "Редактирование", "Присвойте номер задачи", False)
                    Exit Sub
                Else
                    'проверяем номер задачи на совпадение
                    Dim dv As New DataView
                    With dv
                        .Table = globds.idbContext
                        .RowFilter = "colNumber = " & "'" & grdEdit(1, 0).Value.ToString & "'"
                        If dv.Count <> 0 Then
                            bMessage(1, "Редактирование", "Присвойте задаче другой номер: задача с таким номером уже описана", False)
                            Exit Sub
                        End If
                    End With
                End If
                If Len(grdEdit(2, 0).Value.ToString) = 0 Then
                    bMessage(1, "Редактирование", "Опишите функцию, например, так: функция не выпуклая, точка минимума  -  вырожденная, матрица Гесса этой функции в точке минимума сингулярна", False)
                    Exit Sub
                End If
                If Len(grdEdit(3, 0).Value.ToString) = 0 Then
                    bMessage(1, "Редактирование", "Опишите наименование функции, например, так: функция Зангвилла", False)
                    Exit Sub
                End If
                With globds.idbContext
                    Dim row As idbContextRow = .NewidbContextRow
                    With row
                        .Id = CType(grdEdit(0, 0).Value, Guid)
                        .colNumber = CShort(grdEdit(1, 0).Value)
                        .colNote = grdEdit(2, 0).Value.ToString
                        .colValue = grdEdit(3, 0).Value.ToString
                    End With
                    .AddidbContextRow(row)
                    bs.Position = bs.Find("Id", CType(grdEdit(0, 0).Value, Guid))
                End With
        End Select
        Call ModeWork(True)
        If intUpdate <> 2 Then intUpdate = 1
    End Sub

    Private Sub btnOk_Click(ByVal sender As Object, ByVal e As EventArgs)
        Cursor = WaitCursor
        berror = False 'признак ошибки при описании параметров задачи
        Dim m As Integer 'm = n -1 
        Try
            Dim dv As New DataView
            With dv
                'параметры настройки
                .Table = globds.idbTools
                .RowFilter = "Id = " & "'" & globGuid.ToString & "'"
                .Sort = "colNumber"
                n = CInt(dv(0)("colValue"))
                Dim s As String
                s = dv(1)("colValue").ToString.Replace(".", ",")
                alfa = CDbl(s)
                kmax = CInt(dv(2)("colValue"))
                nr = CInt(dv(3)("colValue"))
                mex = CInt(dv(4)("colValue"))
                s = dv(5)("colValue").ToString.Replace(".", ",")
                beta = CDbl(s)
                s = dv(6)("colValue").ToString.Replace(".", ",")
                gamma = CDbl(s)
                'стартовая точка
                .Table = globds.idbX
                .RowFilter = "Id = " & "'" & globGuid.ToString & "'"
                .Sort = "colNumber"
                m = n - 1
                ReDim xk(m)
                Dim i As Integer
                For i = 0 To m
                    Try
                        s = dv(i)("colValue").ToString.Replace(".", ",")
                        xk(i) = CDbl(s)
                    Catch ex As Exception
                        bMessage(1, globProblem, "Отредактируйте строку " & i + 1 & " описания стартовой точки", False)
                        Exit Sub
                    End Try
                Next
                'текстовое описание функции
                .Table = globds.idbF
                .RowFilter = "Id = " & "'" & globGuid.ToString & "'"
                sF = dv(0)("colValue").ToString
            End With
            'признак перехода к альтернативному направлению спуска
            If chk.CheckState = CheckState.Checked Then
                balternative = True
            Else
                balternative = False
            End If
        Catch ex As Exception
            bMessage(1, globProblem, "Проверьте описание параметров приложения", False)
            Cursor = Hand
            Exit Sub
        End Try
        'вычислить значение Fk в стартовой точке, положить nf = 1
        Fk = func(sF, xk)
        If berror Then Exit Sub
        nf = 1
        'оценить конечно-разностные интервалы
        ReDim h(m)
        Call AutomaticIntervals()
        'решение
        Call Mnb()
        If Not berror Then
            Dim frmWyw As New frmWyw
            With frmWyw
                .Text = globProblem
                .ShowDialog()
            End With
        End If
        Cursor = Hand
    End Sub

    Private Sub btnIdb_Click(ByVal sender As Object, ByVal e As EventArgs)
        Call UpdateIdb()
    End Sub

End Class